#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=162.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <file.au3>
#include <array.au3>

Opt("TrayMenuMode", 3)
Opt("TrayAutoPause",0)

Local $Versionitem  = TrayCreateItem("Auto hide folder tree of Directory Opus")
Local $Createitem  = TrayCreateItem("Create by Thomas Michiels (AlbatorV)")
Local $create_blank = TrayCreateItem("")
Local $exit = TrayCreateItem("Exit")
TraySetToolTip("Auto hide folder tree of Directory Opus")

WinWaitActive("[CLASS:dopus.lister]")

While 1
    Local $msg = TrayGetMsg()
    Select
        Case $msg = 0
            
If WinActive("[CLASS:dopus.lister]") Then
	$size = WinGetPos("[CLASS:dopus.lister]")
	$lister = ControlGetPos("[CLASS:dopus.lister]","","[CLASS:dopus.filedisplay]") 
	$pos = MouseGetPos()
	
	If $pos[0] > $size[0] and $pos[0] < $size[0]+12 and $pos[1] > $size[1]+$lister[1]+30 and $pos[1] < $size[1]+$size[3]-30 Then
		Local $ret = _GetActiveWinEXEPath("dopus.exe")
		Dim $szDrive, $szDir, $szFName, $szExt
		$do = _PathSplit($ret, $szDrive, $szDir, $szFName, $szExt)
		Run($do[1] & $do[2] & "dopusrt.exe /cmd Set TREE=Toggle")
		sleep(500)
	EndIf
EndIf

Case $msg = $exit
            ExitLoop
EndSelect
WEnd

Func _GetActiveWinEXEPath($filename, $title = "")
    Local $hWnd, $aWinList, $aProcList, $mode, $pid, $hProc, $stHMod, $stCB, $resEnum, $resPath, $err
    If Not ProcessExists($filename) Then
        SetError(1)
        Return ""
    EndIf
    $mode = Opt("WinTitleMatchMode", 2) ; Match any substring in the title
    If $title <> "" Then
        $aWinList = WinList($title, "")
    Else
        $aWinList = WinList()
    EndIf
    Opt("WinTitleMatchMode", $mode)
    $aProcList = ProcessList($filename)
    For $i1 = 1 To $aWinList[0][0]
        If $aWinList[$i1][0] <> "" Then
            For $i2 = 1 To $aProcList[0][0]
                $pid = $aProcList[$i2][1]
                $hProc = DllCall("kernel32.dll", "int", "OpenProcess", "int", _
                        0x0410, "int", False, "int", $pid)
                $err = @error
                If $err Then
                    If $hProc[0] Then DllCall("kernel32.dll", 'int', 'CloseHandle', 'int', $hProc[0])
                    SetError($err, @extended, 0)
                    Return ""
                EndIf
                If $hProc[0] Then
                    $stHMod = DllStructCreate("int hMod")
                    $stCB = DllStructCreate("dword cbNeeded")
                    $resEnum = DllCall("psapi.dll", "int", "EnumProcessModules", _
                            "int", $hProc[0], "ptr", DllStructGetPtr($stHMod), "dword", _
                            DllStructGetSize($stHMod), "ptr", DllStructGetPtr($stCB, 1))
                    $err = @error
                    If $err Then
                        DllCall("kernel32.dll", 'int', 'CloseHandle', 'int', $hProc[0])
                        SetError($err, @extended, 0)
                        Return ""
                    EndIf
                    If $resEnum[0] Then
                        $resPath = DllCall("psapi.dll", "int", "GetModuleFileNameEx", _
                                "int", $hProc[0], "int", DllStructGetData($stHMod, 1), _
                                "str", "", "dword", 32768)
                        $err = @error
                        DllCall("kernel32.dll", 'int', 'CloseHandle', 'int', $hProc[0])
                        If $err Then
                            SetError($err, @extended, 0)
                            Return ""
                        EndIf
                        If WinGetProcess($aWinList[$i1][1]) = $pid Then
                            $hWnd = $aWinList[$i1][1]
                            If BitAND(WinGetState($hWnd, ""), 8) Then
                                If FileExists($resPath[3]) Then
                                    SetError(0)
                                    Return $resPath[3]
                                Else
                                    SetError(1)
                                    Return ""
                                EndIf
                            EndIf
                        EndIf
                    EndIf
                    $stHMod = 0
                    $stCB = 0
                    If $hProc[0] Then DllCall("kernel32.dll", 'int', 'CloseHandle', 'int', $hProc[0])
                    If @error Then
                        SetError(@error, @extended, 0)
                        Return ""
                    EndIf
                EndIf
            Next
        EndIf
    Next
    SetError(1)
    Return ""
EndFunc   ;==>_GetActiveWinEXEPath
